program Linija;
uses Crt,Graph;
const nn=10;
      dld=5;
var
 GraphDriver, GraphMode: Integer;
 Color: Word;
 Palette: PaletteType;
 ErrCode :Integer;
 MaxDl:Real;
 Gd,Gm,X,Y,TD:integer;

{$F+}
function xc:integer;
begin
    xc:=0;
end;
{$F-}

Procedure Palete;
 Begin
  SetRGBPalette(0,0,0,0);
  SetRGBPalette(1,10,10,10);
  SetRGBPalette(2,20,20,20);
  SetRGBPalette(3,20,20,20);
  SetRGBPalette(4,25,25,25);
  SetRGBPalette(5,30,30,30);
  SetRGBPalette(6,35,35,35);
  SetRGBPalette(7,40,40,40);
  SetRGBPalette(8,45,45,45);
  SetRGBPalette(9,50,50,50);
  SetRGBPalette(10,63,63,63);
  ErrCode := GraphResult;
 end; {Palete}

Procedure LineSegment(x0,y0,x1,y1:integer; index:word);
 var Dx,Dy,D,d1,d2,x,y:Integer;
 Begin
  Dx:=x1-x0; Dy:=y1-y0;
  D:=2*Dy-Dx;
  d1:=2*Dy; d2:=2*(Dy-Dx);
  x:=x0; y:=y0;
  PutPixel(x,y,index);
  While x<x1
   do begin
   if d<=0
      then begin D:=D+d1; Inc(x); end
      else begin D:=D+d2; Inc(x); Inc(y); end;
   PutPixel(x,y,index);
   end; {while}
End; {LineSegment}

Procedure AntialiasedLineSegment(x0,y0,x1,y1:integer);
 var m,y,d,Dl:real;
     Dx,Dy,x,Yapt: Integer;

 Function Dist(x3,y3:integer):real;
 var ddd:real;
  Begin
   ddd:=(x3*Dy-y3*Dx-x0*Dy+y0*Dx)/SQRT(SQR(Dx)+SQR(Dy));
   Dist:=ddd;
  End; {Dist}

 Function Index(dd:real):integer;
  var Result:integer;
  Begin
   Result:=nn-Round(abs(dd/dld)*nn);
   if result<0 then Index:=0 else Index:=Result;
  End; {Index}

 Begin
  Dx:=x1-x0; Dy:=y1-y0;
  m:=Dy/Dx;
  Dl:=Dx/SQRT(Dx*Dx+Dy*Dy);
  MaxDl:=Dl;
  y:=y0;
  For x:=x0 to x1
   do begin
      Yapt:=Round(y); d:=Dist(x,Yapt);
        PutPixel(x,Yapt-1,Index(d+Dl));
        PutPixel(x,Yapt,Index(d));
        PutPixel(x,Yapt+1,Index(d-Dl));
      y:=y+m;
   end; {for}
end; {AntialiasedLineSegment}

Begin

   TD:=InstallUserDriver('svga256',@xc);
   Gd:=Detect;
   InitGraph(Gd,Gm,' ');
   if GraphResult<>0 then Halt;

{-------------------------------------------------------------------------}
Palete;
LineSegment(5,15,500,200,8);
LineSegment(5,5,480,50,8);
AntialiasedLineSegment(5,65,500,250);
AntialiasedLineSegment(5,55,480,100);
{-------------------------------------------------------------------------}
ReadKey;
CloseGraph;
end.
