#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "graphics.c"
#define N 2001

float Frand();
short x[N],y[N],xcentr,ycentr,n,demo; float key[N];

main()
{ OpenGraphics(); _setwindow(1,0,0,639,479);
  while(1)
  { printf("n demo: "); scanf("%d %d",&n,&demo);
    if( n <= 0 || n > 2000) exit(0);
    _setcolor(15);
    RandPconf();
    PconfCenter();
    PconfSort();
    PconfDispley();
    Convhull();
    getch();
    _clearscreen(_GCLEARSCREEN);
  }
  CloseGraphics();
}

RandPconf()
{ short i;
  for( i=1; i<=n; i++)
  { x[i]=500*Frand(); y[i]=400*Frand();}
}

PconfCenter()
{ short i; long xc=0,yc=0;
  for( i=1; i<=n; i++) { xc+=x[i]; yc+=y[i];}
  xcentr=xc/n; ycentr=yc/n;
}

PconfDispley()
{ short i;
  for( i=1; i<=n; i++) { _setpixel_w(x[i],y[i]);}
}

float Frand()
{ return((rand()%32000)/32000.);}

PconfSort()
{ short i,t; float c;
  if( n <= 2) return(0);
  for( i=1; i<=n; i++)
   key[i]= x[i] != xcentr || y[i] != ycentr ? atan2(y[i]-ycentr,x[i]-xcentr)
					    : 0;
  for( i=n/2; i>=1; i--) Heap(i,n);
  for( i=n; i>=2; i--)
   { t=x[1]; x[1]=x[i]; x[i]=t;
     t=y[1]; y[1]=y[i]; y[i]=t;
     c=key[1]; key[1]=key[i]; key[i]=c;
     Heap(1,i-1);
   }
}

Heap(i,j)
short i,j;
{ short k,t; float w0,wl,wr,c;
  w0=key[i];
  if( 2*i  <= j) wl=key[2*i];   else wl=w0;
  if( 2*i+1<= j) wr=key[2*i+1]; else wr=w0;
  if( w0 < max(wl,wr))
  { k= wl < wr ? 2*i+1 : 2*i;
    t=x[i]; x[i]=x[k]; x[k]=t;
    t=y[i]; y[i]=y[k]; y[k]=t;
    c=key[i]; key[i]=key[k]; key[k]=c;
    Heap(k,j);
  }
}

Convhull()
{ short i,i0,next[N],prev[N],infinity=32000,xmin,ymin;
  if( n < 2) return(0);
  for( i=1; i<=n; i++) { next[i]=i+1; prev[i]=i-1; }
  next[n]=1; prev[1]=n;
  ymin=infinity;
  for( i=1; i<=n; i++)
   if ((y[i] < ymin) || (y[i] == ymin) && (x[i] > xmin))
   { i0=i; xmin=x[i]; ymin=y[i]; }
  i=i0;
  _setcolor(7);
  if( n > 2)
  while( next[i] != i0)
   { if(demo) { _moveto_w(x[i],y[i]); _lineto_w(x[next[i]],y[next[i]]);}
     if( Leftturn(i,next[i],next[next[i]])) { i=next[i]; if(demo==2) getch();}
     else { next[i]=next[next[i]]; prev[next[i]]=i; if( i != i0) i=prev[i];}
   }
  i=i0;
  _moveto_w(x[i],y[i]);
  do { _lineto_w(x[next[i]],y[next[i]]);
       i=next[i];
     }
  while( i != i0);
  getch();
  SetAAColors();
  i=i0;
  do { AALine(x[i],y[i],x[next[i]],y[next[i]],1);
       i=next[i];
     }
  while( i != i0);
}

Leftturn(i1,i2,i3)
short i1,i2,i3;
{ return((long)(x[i2]-x[i1])*(y[i3]-y[i1])-
	 (long)(y[i2]-y[i1])*(x[i3]-x[i1]) > 0);
}

