uses Crt, Graph;
var Gd, Gm: Integer;
const kmax = 8;
      x11= 57; x12=141; y11= 5; y12=25;
      x21=170; x22=254; y21= 5; y22=25;
      x31=283; x32=367; y31= 5; y32=25;
      x41=387; x42=471; y41= 5; y42=25;
      x51= 57; x52=141; y51=30; y52=50;
      x61=170; x62=254; y61=30; y62=50;
      x71=283; x72=367; y71=30; y72=50;
      x81=387; x82=471; y81=30; y82=50;
      dx=5; dy=1;
var i,k,l,textX,textY: integer;
    c:char; s,ss:string[kmax];
    v,a0,a1,a2,a3,b0,b1,b2,b3:real;
label Exit;

 function CharValue(c:char):real;
 begin  case c of
        '0': CharValue:=0;
        '1': CharValue:=1;
        '2': CharValue:=2;
        '3': CharValue:=3;
        '4': CharValue:=4;
        '5': CharValue:=5;
        '6': CharValue:=6;
        '7': CharValue:=7;
        '8': CharValue:=8;
        '9': CharValue:=9;
        end
 end;

 function StringValue(s:string):real;
 var i,i1,l,z:integer; v,q:real;
     intpart:Boolean;
 begin l:=Length(s); if l = 0 then Stringvalue:=0;
       i1:=1; z:=1;
       if (s[1] = '+') or (s[1] = ' ') then i1:=2;
       if s[1] = '-' then begin z:=-1; i1:=2 end;
       v:=0; q:=10; intpart:=true;
       for i:=i1 to l
       do if Ord(s[i]) < 48
          then intpart:=false
          else if intpart
               then v:=v*10+CharValue(s[i])
               else if Ord(s[i]) >= 48 then begin
                                         v:=v+CharValue(s[i])/q;
                                         q:=q*10
                                         end;
       StringValue:=v*z;
 end;

 procedure SetFactor;
 var v:real;
 begin
 v:=StringValue(s);
 case l of
 1: a3:=v; 2: a2:=v; 3: a1:=v; 4: a0:=v;
 5: b3:=v; 6: b2:=v; 7: b1:=v; 8: b0:=v;
 end
 end;

 procedure TextXY(x,y:integer);
 begin textX:=x; textY:=y
 end;

 procedure ClearWin;
 begin SetFillStyle(1, 0);
       case l of
       1: begin bar3d(x11,y11,x12,y12,0,TopOn); TextXY(x11+dx,y11+dy);
          end;
       2: begin bar3d(x21,y21,x22,y22,0,TopOn); TextXY(x21+dx,y21+dy);
          end;
       3: begin bar3d(x31,y31,x32,y32,0,TopOn); TextXY(x31+dx,y31+dy);
          end;
       4: begin bar3d(x41,y41,x42,y42,0,TopOn); TextXY(x41+dx,y41+dy);
          end;
       5: begin bar3d(x51,y51,x52,y52,0,TopOn); TextXY(x51+dx,y51+dy);
          end;
       6: begin bar3d(x61,y61,x62,y62,0,TopOn); TextXY(x61+dx,y61+dy);
          end;
       7: begin bar3d(x71,y71,x72,y72,0,TopOn); TextXY(x71+dx,y71+dy);
          end;
       8: begin bar3d(x81,y81,x82,y82,0,TopOn); TextXY(x81+dx,y81+dy);
          end;
       end
 end;

 procedure SetLattice;
 var i: integer;
 begin SetViewPort(0, 60, 639, 479, true); ClearViewPort;
       setpalette(1,1); setrgbpalette(1,20,20,20);
       setpalette(2,2); setrgbpalette(2,26,26,26);
       setpalette(3,3); setrgbpalette(3,37,37,37);
       setcolor(1);
       for i:=1 to 40 do line(20*i,0,20*i,480);
       for i:=0 to 20 do line(0,20*i+10,640,20*i+10);
       setcolor(2);
       for i:=0 to 6 do line(100*i+20,0,100*i+20,480);
       for i:=0 to 4 do line(0,100*i+10,640,100*i+10);
       setcolor(3);
       line(0,210,640,210); line(320,0,320,480);
 end;

 procedure DrawCurve;
 var t,dt,xd,yd: real;
     x,y: integer;
 begin t:=-1;
       x:= Round(((((a3*t+a2)*t)+a1)*t+a0)*20)+320;
       y:=-Round(((((b3*t+b2)*t)+b1)*t+b0)*20)+210;
       {putpixel(x,y,15);} setcolor(15); moveto(x,y);
       while t < 1 do
       begin if keypressed then if Ord(readkey) = 27 then halt;
             xd:=Abs((3*a3*t+2*a2)*t+a1);
             yd:=Abs((3*b3*t+2*b2)*t+b1);
             if xd > yd then dt:=0.05/xd else dt:=0.05/yd;
             t:=t+dt;
             x:= Round(((((a3*t+a2)*t)+a1)*t+a0)*20)+320;
             y:=-Round(((((b3*t+b2)*t)+b1)*t+b0)*20)+210;
             {putpixel(x,y,15);} lineto(x,y)
       end;
       SetViewPort(0, 0, 639, 479, true);
 end;

begin
 Gd := Detect;
 InitGraph(Gd, Gm, 'c:\bp\bgi');
 if GraphResult <> grOk then  Halt(1);

 ellipse(0,17,270,0,5,10); ellipse(10,16,90,180,5,7);
 ellipse(0,37,0,90,5,10);  ellipse(10,38,180,270,5,8);
 SetTextStyle(2, HorizDir, 5);
 moveto(154,0); outtext('3'); moveto(154,25); outtext('3');
 moveto(270,0); outtext('2'); moveto(270,25); outtext('2');
 SetTextStyle(2, HorizDir, 6);
 moveto(10,5);
 outtext(' x =  8.12345 t  +4.12345 t  -4.12345 t +0.12345');
 moveto(10,30);
 outtext(' y =  0.12345 t  +9.12345 t  +0.12345 t +0.12345');
 outtextXY(550,18,'t   [-1,1]');
 ellipse(568,29,90,270,3,3);
 line(569,26,575,26); line(569,32,575,32); line(567,29,571,29);
 a3:=8.12345; a2:=4.12345; a1:=-4.12345; a0:=0.12345;
 b3:=0.12345; b2:=9.12345; b1:= 0.12345; b0:=0.12345;
 l:=1;
 setcolor(15); rectangle(x11,y11,x12,y12);
 TextXY(x11+dx,y11+dy);
 while true do
 begin
 c:=ReadKey;
 case Ord(c) of
 27: goto Exit;
  9: begin
     case l of
     1: begin setcolor(0);  rectangle(x11,y11,x12,y12);
              l:=2; if k > 0 then a3:=StringValue(s);
              setcolor(15); rectangle(x21,y21,x22,y22);
              TextXY(x21+dx,y21+dy);
        end;
     2: begin setcolor(0);  rectangle(x21,y21,x22,y22);
              l:=3; if k > 0 then a2:=StringValue(s);
              setcolor(15); rectangle(x31,y31,x32,y32);
              TextXY(x31+dx,y31+dy);
        end;
     3: begin setcolor(0);  rectangle(x31,y31,x32,y32);
              l:=4; if k > 0 then a1:=StringValue(s);
              setcolor(15); rectangle(x41,y41,x42,y42);
              TextXY(x41+dx,y41+dy);
        end;
     4: begin setcolor(0);  rectangle(x41,y41,x42,y42);
              l:=5; if k > 0 then a0:=StringValue(s);
              setcolor(15); rectangle(x51,y51,x52,y52);
              TextXY(x51+dx,y51+dy);
        end;
     5: begin setcolor(0);  rectangle(x51,y51,x52,y52);
              l:=6; if k > 0 then b3:=StringValue(s);
              setcolor(15); rectangle(x61,y61,x62,y62);
              TextXY(x61+dx,y61+dy);
        end;
     6: begin setcolor(0);  rectangle(x61,y61,x62,y62);
              l:=7; if k > 0 then b2:=StringValue(s);
              setcolor(15); rectangle(x71,y71,x72,y72);
              TextXY(x71+dx,y71+dy);
        end;
     7: begin setcolor(0);  rectangle(x71,y71,x72,y72);
              l:=8; if k > 0 then b1:=StringValue(s);
              setcolor(15); rectangle(x81,y81,x82,y82);
              TextXY(x81+dx,y81+dy);
        end;
     8: begin setcolor(0);  rectangle(x81,y81,x82,y82);
              l:=1; if k > 0 then b0:=StringValue(s);
              setcolor(15); rectangle(x11,y11,x12,y12);
              TextXY(x11+dx,y11+dy);
        end;
     end;
     k:=0; s:=''
     end;
 43, 45, 46, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57:
     begin
     Inc(k);
     if (k = 1) and (Ord(c) > 45)
     then begin Inc(k); if (l = 1) or (l = 5) then s:=s+' '
                                              else s:=s+'+'
          end;
     if k <= kmax then begin s:=s+c;
                             ss:=''; for i:=1 to kmax-k do ss:=ss+' ';
                             ss:=ss+s;
                             ClearWin; outtextXY(textX,textY,ss)
                       end;
     SetFactor
     end;
 32: begin
     k:=0; s:='';
     SetFactor;
     ClearWin
     end;
 13: begin
     k:=0; s:='';
     SetLattice; DrawCurve;
     end;
 end;
 end;
Exit: CloseGraph;
end.
