#include <stdio.h>
#include <stdlib.h>
#include <graph.h>
#include <math.h>
#include "graphics.c"

float t1=0; t2=400; c=1;
main()
{
  OpenGraphics();
  DrawCurve1();
  getch();
  CloseGraphics();
}

float f(float t)
{ return(c*t*cos(t)+320);
}

float g(float t)
{ return(c*t*sin(t)+240);
}

float fd(float t)
{ return(c*(cos(t)-t*sin(t)));
}

float gd(float t)
{ return(c*(sin(t)+t*cos(t)));
}

/*
float f(float t)
{ return(t);
}

float g(float t)
{ return(t*t/1);
}

float fd(float t)
{ return(1);
}

float gd(float t)
{ return(2*t/1);
}
*/
DrawCurve0()
{ float t,dt,x,y,xd,yd;
  t=t1;
  x=f(t); y=g(t); _setpixel((short)(x+0.5),(short)(y+0.5));
  while( t < t2)
  { t+=0.5;
    x=f(t); y=g(t); _setpixel((short)(x+0.5),(short)(y+0.5));
  }
}

DrawCurve1()
{ float t,dt,x,y,xd,yd;
  t=t1;
  x=f(t); y=g(t); _setpixel((short)(x+0.5),(short)(y+0.5));
		  //  _moveto((short)(x+0.5),(short)(y+0.5));
  while( t < t2)
  { xd=fabs(fd(t)); yd=fabs(gd(t));
    dt=( xd > yd)? 1/xd: 1/yd;
    t+=dt;
    x=f(t); y=g(t); _setpixel((short)(x+0.5),(short)(y+0.5));
		    //  _lineto((short)(x+0.5),(short)(y+0.5));
  }
}

DrawCurve2()
{ float t,dt,xd,yd,xda,yda;
  short x,y,xv,yv;
  t=t1;
  xv=f(t)+0.5; yv=g(t)+0.5; _setpixel(xv,yv);
  while( t < t2)
  { xd=fd(t); xda=fabs(xd); yd=gd(t); yda=fabs(yd);
    if( xda > 1.0001*yda)
    { t+=1/xda;
      x=f(t)+0.5; y=g(t)+0.5; _setpixel(x,y);
      if( xd > 0 && x > xv+1) _setpixel(x-1,y);
      if( xd < 0 && x < xv-1) _setpixel(x+1,y);
    }
    else if( yda > 1.0001*xda)
    { t+=1/yda;
      x=f(t)+0.5; y=g(t)+0.5; _setpixel(x,y);
      if( yd > 0 && y > yv+1) _setpixel(x,y-1);
      if( yd < 0 && y < yv-1) _setpixel(x,y+1);
    }
    else
    { t+=1/xda;
      x=f(t)+0.5; y=g(t)+0.5; _setpixel(x,y);
      if( yd > 0 && y > yv+1) _setpixel(x-1,y-1);
      if( yd < 0 && y < yv-1) _setpixel(x+1,y+1);
    }
    xv=x; yv=y;
  }
}
