#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "graphics.c"
#include "keyinput.c"
#define PI 3.14159

short modstat,ringstat=1,
      h,s,l,r,g,b,c,w,xc=195,yc=130,xca=197,yca=132,m[20][20];

long pal[256];
main()
{ char txt[80];
  OpenGraphics256();
  _remappalette(0,RGB(30,30,30));
  _remappalette(254,RGB(0,0,0));
  l=100;
  SetRingPalette();
  SetColorRing(ringstat);
  _settextcolor(254);
  h=0; s=100; modstat=1;
  _setcolor(w);
  _rectangle( _GBORDER, 0, 0, 121, 180);
  _rectangle( _GBORDER, 273, 79, 280, 180);
  _rectangle( _GBORDER, 304, 79, 311, 180);
  while(1)
  { SetRGB();
    _remappalette(255,RGB(r,g,b));
    _setcolor(255);
    _rectangle( _GFILLINTERIOR, 1, 1, 120, 179);
    switch (modstat)
    { case 1: SetHueArc();
	      _setcolor(254);
	      _rectangle(_GFILLINTERIOR, 195, 190, 200, 194); break;
      case 2: _setcolor(0);
	      if(s > 0) _rectangle( _GFILLINTERIOR, 274, 180-s, 279, 179);
	      _setcolor(254);
	      if(s < 100) _rectangle( _GFILLINTERIOR, 274, 80, 279, 179-s);
	      _rectangle(_GFILLINTERIOR, 274, 190, 279, 194); break;
      case 3: _setcolor(0);
	      if(l > 0) _rectangle( _GFILLINTERIOR, 305, 180-l, 310, 179);
	      _setcolor(254);
	      if(l < 100) _rectangle( _GFILLINTERIOR, 305, 80, 310, 179-l);
	      _rectangle(_GFILLINTERIOR, 305, 190, 310, 194);
    }
    sprintf(txt,"%3d       %3d %3d",h,s,l);
    _settextposition(9,24); _outtext(txt);
    sprintf(txt,"%2d %2d %2d",r,g,b);
    _settextposition(1,32); _outtext(txt);
    ModifColor();
  }
}

SetRingPalette()
{ short i,j,r2,di=3,dj=2,rx=54,ry=45;
  for(i=0; i<20; i++) for(j=0; j<20; j++) m[i][j]=0;
  c=0;
  for(i=-9; i<10; i++)
   for(j=-9; j<10; j++)
   { r2=i*i+j*j;
     if( r2 <= 82 && r2 != 80)
     { s=sqrt(r2*10000./81);
       h=(r2==0)? 0: atan2(i,j)*180/PI; if( h < 0) h+=360;
       c++; SetRGB(); _remappalette(c,RGB(r,g,b));
       if( r2 == 0) w=c;
       m[i+10][j+10]=c;
     }
   }
}

SetColorRing()
{ short i,j,r2,di=3,dj=2,rx=54,ry=45;
  for(i=-9; i<10; i++)
   for(j=-9; j<10; j++)
    if( m[i+10][j+10] == 0)
     if( j != 0) m[i+10][j+10]=(i < 0)? m[i+9][j+10]=10: m[i+10][j+11];
  for(i=-9; i<10; i++)
   for(j=-9; j<10; j++)
   { r2=i*i+j*j;
     if( r2 <= 74)
     switch (ringstat)
     { case 1:
       _setcolor(m[i+10][j+10]);
       _rectangle(_GFILLINTERIOR, xc+6*i, yc+5*j, xc+6*i+5, yc+5*j+4);
       break;
       case 2:
       _setcolor(m[i+10][j+10]);
       _rectangle(_GFILLINTERIOR, xc+6*i+1, yc+5*j+1, xc+6*i+4, yc+5*j+3);
       _setpixel( xc+6*i-1, yc+5*j-1); _setpixel( xc+6*i-1, yc+5*j+5);
       _setpixel( xc+6*i+6, yc+5*j-1); _setpixel( xc+6*i+6, yc+5*j+5);
       _setpixel( xc+6*i-1, yc+5*j+2); _setpixel( xc+6*i+6, yc+5*j+2);
       _setpixel( xc+6*i+1, yc+5*j-1); _setpixel( xc+6*i+3, yc+5*j-1);
       _setpixel( xc+6*i+1, yc+5*j+5); _setpixel( xc+6*i+3, yc+5*j+5);
       _setpixel( xc+6*i  , yc+5*j+1); _setpixel( xc+6*i  , yc+5*j+3);
       _setpixel( xc+6*i+5, yc+5*j+1); _setpixel( xc+6*i+5, yc+5*j+3);
       _setpixel( xc+6*i+2, yc+5*j  ); _setpixel( xc+6*i+4, yc+5*j  );
       _setpixel( xc+6*i+2, yc+5*j+4); _setpixel( xc+6*i+4, yc+5*j+4);
       break;
     }
   }
  _setcolor(0);
  for(i=-di; i<=di; i++)
   for(j=-dj; j<=dj; j++)
    _ellipse(_GBORDER, xca+i-rx, yca+j-ry, xca+i+rx, yca+j+ry);
  _setcolor(w);
  _ellipse(_GBORDER, xca-54, yca-45, xca+54, yca+45);
  _ellipse(_GBORDER, xca-60, yca-51, xca+60, yca+51);
}

SetRGB()
{ short r0,g0,b0;
/*  if( h < 120)
  { r0=63*(120-h)/120; g0=63*h/120; b0=0; }
    else if( h < 240)
    { r0=0; g0=63*(240-h)/120; b0=63*(h-120)/120; }
    else
    { r0=63*(h-240)/120; g0=0; b0=63*(360-h)/120; }   */
  if( h < 60)
  { r0=63; g0=63*h/60; b0=0; }
  else if( h < 120)
  { r0=63*(120-h)/60; g0=63; b0=0; }
  else if( h < 180)
  { r0=0; g0=63; b0=63*(h-120)/60; }
  else if( h < 240)
  { r0=0; g0=63*(240-h)/60; b0=63; }
  else if( h < 300)
  { r0=63*(h-240)/60; g0=0; b0=63; }
  else
  { r0=63; g0=0; b0=63*(360-h)/60; }
    r=(long)(63*(100-s)+s*r0)*l/10000;
    g=(long)(63*(100-s)+s*g0)*l/10000;
    b=(long)(63*(100-s)+s*b0)*l/10000;
}

SetHueArc()
{ short i,j,x1,y1,x2,y2,x3,y3,x4,y4;
  _setcolor(254);
  for(i=0; i<=4; i++)
   for(j=0; j<=4; j++)
    _ellipse(_GBORDER, xca-i-55, yca-j-46, xca+i+55, yca+j+46);
  _setcolor(0);
  if( h > 0)
   for(i=0; i<=4; i++)
    for(j=0; j<=4; j++)
     { x1=xca-55-i; y1=yca-46-j;
       x2=xca+55+i; y2=yca+46+j;
       x3=xca;
       y3=yca+46+j;
       x4=xca+(55+i)*sin(h*PI/180)+0.5;
       y4=yca+(46+j)*cos(h*PI/180)+0.5;
       _arc(x1,y1,x2,y2,x3,y3,x4,y4);
     }
}

ModifH(short k)
{ if( abs(k) == 360) h=0;
  else if( (h+=k) < 0) h+=360; else if(h >= 360) h-=360;
  modstat=1;
}

ModifS(short k)
{ if( (s+=k) < 0) s=0; else if(s > 100) s=100;
  modstat=2;
}

ModifL(short k)
{ if( (l+=k) < 0) l=0; else if(l > 100) l=100;
  modstat=3;
}

ModifStat(short k)
{ if( (modstat+=k) > 3) modstat=1; else if( modstat < 1) modstat=3;
  _setcolor(0);
  _rectangle(_GFILLINTERIOR, 195, 190, 200, 194);
  _rectangle(_GFILLINTERIOR, 274, 190, 279, 194);
  _rectangle(_GFILLINTERIOR, 305, 190, 310, 194);
}

ModifV(short k)
{ switch (modstat)
  { case 1: ModifH(k); return(0);
    case 2: ModifS(k); return(0);
    case 3: ModifL(k); return(0);
  }
}

ModifRing()
{ if( (ringstat+=1) > 2) ringstat=1;
  SetColorRing(ringstat);
  SetHueArc();
}

ModifColor()
{ while(1)
  switch (InputKey())
  { case 'h':      ModifH(0); ModifStat(0); return(0);
    case 's':      ModifS(0); ModifStat(0); return(0);
    case 'l':      ModifL(0); ModifStat(0); return(0);
    case LEFT:     ModifStat(-1); return(0);
    case RIGHT:    ModifStat(1);  return(0);
    case UP:       ModifV(1);     return(0);
    case DOWN:     ModifV(-1);    return(0);
    case PAGEUP:   ModifV(10);    return(0);
    case PAGEDOWN: ModifV(-10);   return(0);
    case HOME:     ModifV(360);   return(0);
    case END:      ModifV(-360);  return(0);
    case TAB:      ModifRing();   return(0);
    case ESC:      CloseGraphics(); exit(0);
  }
}
