#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "graphics.c"

short intR[256],intG[256],intB[256]; long pal[256];
float f();
main()
{ short k;
  OpenGraphics256();
  pal[0]=RGB(10,10,10);
  pal[253]=RGB(63,0,0); pal[254]=RGB(0,63,0); pal[255]=RGB(0,0,63);
  Spektrs1(); SetPalette(); Zime();
  while( 1)
  { switch (getch())
    { case '1': Spektrs1(); break;
      case '2': Spektrs2(); break;
      case '3': Spektrs3(); break;
      case 27 : CloseGraphics(); exit(0);
    }
    SetPalette(); Zime();
  }
}

Zime()
{ short k;
  _setcolor(0); _rectangle(_GFILLINTERIOR,0,0,300,100);
  for( k = 1; k <= 252; k++)
  { _setcolor(255); _setpixel(k+32, 90-intB[k]);
    _setcolor(254); _setpixel(k+32, 90-intG[k]);
    _setcolor(253); _setpixel(k+32, 90-intR[k]);
    _setcolor(k); _moveto(k+32,120); _lineto(k+32,170);
  }
  _settextposition(14, 4); printf("400");
  _settextposition(14,14); printf("500");
  _settextposition(14,24); printf("600");
  _settextposition(14,35); printf("700");
}

SetPalette()
{ short k;
  for( k = 1; k <= 252; k++) pal[k]=RGB(intR[k],intG[k],intB[k]);
  if( !_remapallpalette( pal ) )
   { _setvideomode( _DEFAULTMODE );
     _outtext( "Palettes not available with this adapter" );
     exit( 1 );
   }
}

Spektrs1()
{ short k;
  for( k =  1; k <=252; k++) { intR[k]=0; intG[k]=0; intB[k]=0; }
  for( k =  1; k <= 42; k++)
  intR[k]=min(63,max(0,f((float)k,  1., 20.,0., 42., 20.,0.)));
  for( k =127; k <=168; k++)
  intR[k]=min(63,max(0,f((float)k,126., 50.,0.,168., 50.,0.)));
  for( k =169; k <=210; k++)
  intR[k]=min(63,max(0,f((float)k,126., 63.,0.,210., 63.,0.)));
  for( k =211; k <=252; k++)
  intR[k]=min(63,max(0,f((float)k,126., 40.,0.,252., 40.,0.)));
  for( k = 85; k <=126; k++)
  intG[k]=min(63,max(0,f((float)k, 85., 32.,0.,168., 32.,0.)));
  for( k =127; k <=168; k++)
  intG[k]=min(63,max(0,f((float)k, 85., 40.,0.,168., 40.,0.)));
  for( k =169; k <=210; k++)
  intG[k]=min(63,max(0,f((float)k,169., 21.,0.,210., 21.,0.)));
  for( k =  1; k <= 42; k++)
  intB[k]=min(63,max(0,f((float)k,  1., 32.,0., 42., 32.,0.)));
  for( k = 43; k <= 84; k++)
  intB[k]=min(63,max(0,f((float)k, 43., 63.,0., 84., 63.,0.)));
}

Spektrs2()
{ short k;
  for( k =  1; k <=252; k++) { intR[k]=0; intG[k]=0; intB[k]=0; }
  for( k =  1; k <= 32; k++)
  intR[k]=min(63,max(0,f((float)k,  1.,  2.,0.1, 32., 20.,0.)))+0.5;
  for( k = 33; k <= 84; k++)
  intR[k]=min(63,max(0,f((float)k, 32., 20.,0.0, 84.,  0.,0.)))+0.5;
  for( k = 85; k <=168; k++)
  intR[k]=min(63,max(0,f((float)k, 85.,  0.,0.0,168., 45.,0.)))+0.5;
  for( k =169; k <=252; k++)
  intR[k]=min(63,max(0,f((float)k,168., 45.,0.0,252.,  0.,0.)))+0.5;
  for( k = 42; k <=126; k++)
  intG[k]=min(63,max(0,f((float)k, 42.,  0.,0.0,126., 40.,0.)))+0.5;
  for( k =127; k <=210; k++)
  intG[k]=min(63,max(0,f((float)k,126., 40.,0.0,210.,  0.,0.)))+0.5;
  for( k =  1; k <= 42; k++)
  intB[k]=min(63,max(0,f((float)k,  1.,  5.,0.3, 42., 63.,0.)))+0.5;
  for( k = 43; k <= 95; k++)
  intB[k]=min(63,max(0,f((float)k, 42., 63.,0.0, 95.,  0.,0.)))+0.5;
}

Spektrs3()
{ short k;
  for( k =  1; k <=252; k++) { intR[k]=0; intG[k]=0; intB[k]=0; }
  for( k =  1; k <= 28; k++)
  intR[k]=min(63,max(0,f((float)k,1.,1.,0.3,28.,14.,0.)))+0.5;
  for( k = 29; k <= 84; k++)
  intR[k]=min(63,max(0,f((float)k,28.,14.,0.,84.,0.,-0.2)))+0.5;
  for( k = 85; k <=168; k++)
  intR[k]=min(63,max(0,f((float)k,84.,0.,0.2,168.,40.,0.)))+0.5;
  for( k =169; k <=252; k++)
  intR[k]=min(63,max(0,f((float)k,168.,40.,0.,252.,0.,-0.3)))+0.5;
  for( k =  1; k <= 84; k++)
  intG[k]=min(63,max(0,f((float)k,1.,0.,0.1,84.,15.,0.5)))+0.5;
  for( k = 85; k <=126; k++)
  intG[k]=min(63,max(0,f((float)k,84.,15.,0.5,126.,36.,0.)))+0.5;
  for( k =127; k <=240; k++)
  intG[k]=min(63,max(0,f((float)k,126.,36.,0.,240.,0.,0.)))+0.5;
  for( k =  1; k <= 40; k++)
  intB[k]=min(63,max(0,f((float)k,1.,3.5,0.5,40.,63.,0.)))+0.5;
  for( k = 41; k <= 84; k++)
  intB[k]=min(63,max(0,f((float)k,40.,63.,-0.1,84.,15.,-1.)))+0.5;
  for( k = 85; k <=126; k++)
  intB[k]=min(63,max(0,f((float)k,84.,15.,-1.,126.,0.,0.)))+0.5;
}

float f(x,x1,f1,fp1,x2,f2,fp2)
float x,x1,f1,fp1,x2,f2,fp2;
{ float a0,a1,a2,a3,dx,df,dfp;
  dx=x2-x1; df=f2-f1; dfp=fp2-fp1;
  a3=(fp1+fp2-2*df/dx)/dx/dx;
  a2=(dfp/dx-3*(x1+x2)*a3)/2;
  a1=(fp1+fp2)/2-(x1+x2)*a2-1.5*(x1*x1+x2*x2)*a3;
  a0=(f1+f2-(x1+x2)*a1-(x1*x1+x2*x2)*a2-(x1*x1*x1+x2*x2*x2)*a3)/2;
  return(a0+x*(a1+x*(a2+x*a3)));
}

