#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include "graphics.c"
#define PI 3.14159
#define INF 32767
#define NP    100
#define NBx   150
#define NBy   100
#define NX    300
#define NY    200
#define nSurf 1

float EDist2();

float hx,hy,hz,vx,vy,vz,ax,ay,az,gh,gv,ga;
float p,u1[NP],u2[NP],v1[NP],v2[NP]; short s[NP];
short tp,sx,sy,sz, far **zbuff;
main()
{ short k,n;
  if( (zbuff = (short far **)_fmalloc(NX*sizeof(short far *))) == NULL) exit(1);
  for( k = 0; k < NX; k++)
    if( (zbuff[k] = (short far *)_fmalloc(NY*sizeof(short))) == NULL) exit(2);
  OpenGraphics(); _setwindow(1,0,0,639,479); _setvieworg(320,-240);
  for( k = 0; k < 16; k++)
  _remappalette( k,RGB(10+k*53/15,10+k*53/15,10+k*53/15));
  while( 1)
  { _settextposition(1,1); printf("\nsx sy sz  p: ");
    scanf("%d %d %d %g",&sx,&sy,&sz,&p);
    for( k = 0; k < NX; k++)
     for( n = 0; n < NY; n++) zbuff[k][n] = INF;
    TransfCoef(); Draw();
    printf("*");
    getch();
    _clearscreen(_GCLEARSCREEN);
  }
  CloseGraphics();
  exit(0);
}

TransfCoef()
{ vx=-sx; vy=-sy; vz=-sz;
  hx=vy; hy=-vx; hz=0; if( hx == 0 && hy == 0) { hx=0; hy=1; }
  ax=hy*vz-hz*vy;
  ay=hz*vx-hx*vz;
  az=hx*vy-hy*vx;
  gh=sqrt(hx*hx+hy*hy+hz*hz);
  gv=sqrt(vx*vx+vy*vy+vz*vz);
  ga=sqrt(ax*ax+ay*ay+az*az);
}

Draw()
{ short i;
  for(tp=0; tp<nSurf; tp++)
  { u1[tp]=0.; u2[tp]=1.; v1[tp]=0.; v2[tp]=1.; s[tp]=tp+1; }
  tp=nSurf-1;
  while( tp >= 0)
  { if( kbhit()) if(getch() == 27) exit(0);
    while( !PatchIsSmallV())
    { if(tp+1 > NP-1) exit(112);
      s[tp+1]=s[tp];
      v1[tp+1]=v1[tp]; v2[tp+1]=(v1[tp]+v2[tp])/2;
      u1[tp+1]=u1[tp]; u2[tp+1]=u2[tp];
      v1[tp]=(v1[tp]+v2[tp])/2;
      tp+=1;
    }
    while( !PatchIsSmallU())
    { if(tp+1 > NP-1) exit(112);
      s[tp+1]=s[tp];
      u1[tp+1]=u1[tp]; u2[tp+1]=(u1[tp]+u2[tp])/2;
      v1[tp+1]=v1[tp]; v2[tp+1]=v2[tp];
      u1[tp]=(u1[tp]+u2[tp])/2;
      tp+=1;
    }
    DrawPixel(); tp--;
  }
}

PatchIsSmallU()
{ float x1,y1,z1,x2,y2,z2,xc,yc,zc,nx,ny,nz,d1,d2;
  SurfPoint(s[tp],u1[tp],(v1[tp]+v2[tp])/2,&x1,&y1,&z1,&nx,&ny,&nz);
  SurfPoint(s[tp],u2[tp],(v1[tp]+v2[tp])/2,&x2,&y2,&z2,&nx,&ny,&nz);
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,(v1[tp]+v2[tp])/2,&xc,&yc,&zc,&nx,&ny,&nz);
  d1=EDist2(x1,y1,z1,xc,yc,zc); d2=EDist2(x2,y2,z2,xc,yc,zc);
  if( d1 + d2 <= p) return(1);
  else return(0);
}

PatchIsSmallV()
{ float x1,y1,z1,x2,y2,z2,xc,yc,zc,nx,ny,nz,d1,d2;
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,v1[tp],&x1,&y1,&z1,&nx,&ny,&nz);
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,v2[tp],&x2,&y2,&z2,&nx,&ny,&nz);
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,(v1[tp]+v2[tp])/2,&xc,&yc,&zc,&nx,&ny,&nz);
  d1=EDist2(x1,y1,z1,xc,yc,zc); d2=EDist2(x2,y2,z2,xc,yc,zc);
  if( d1 + d2 <= p) return(1);
  else return(0);
}

float EDist2(x1,y1,z1,x2,y2,z2)
float x1,y1,z1,x2,y2,z2;
{ return((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1));}

DrawPixel()
{ float xc,yc,zc,nx,ny,nz;
  short x,y,k;
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,(v1[tp]+v2[tp])/2,&xc,&yc,&zc,&nx,&ny,&nz);
  x=xc; y=zc;
  if( x <= -NBx || y <= -NBy || x > NBx || y > NBy) return(0);
  if( zbuff[x+NBx][y+NBy] <= yc) return(0);
  zbuff[x+NBx][y+NBy]=yc;
  x *= 2; y *= 2;
  k=30*fabs(ny)/sqrt(nx*nx+ny*ny+nz*nz);
  _setcolor(k/2); _setpixel_w(x,y); _setpixel_w(x+1,y+1);
  _setcolor((k+1)/2); _setpixel_w(x,y+1);_setpixel_w(x+1,y);
}

SurfPoint(s,u,v,xc,yc,zc,nxc,nyc,nzc)
short s; float u,v,*xc,*yc,*zc,*nxc,*nyc,*nzc;
{ float x,y,z,nx,ny,nz;
  switch (s)
  { case 1: Surf1Point(u,v,&x,&y,&z,&nx,&ny,&nz); break;
    case 2: Surf2Point(u,v,&x,&y,&z,&nx,&ny,&nz); break;
    case 3: Surf3Point(u,v,&x,&y,&z,&nx,&ny,&nz); break;
    case 4: Surf4Point(u,v,&x,&y,&z,&nx,&ny,&nz); break;
    case 5: Surf5Point(u,v,&x,&y,&z,&nx,&ny,&nz); break;
  }
  *xc=(hx*x+hy*y+hz*z)/gh;
  *yc=(vx*x+vy*y+vz*z)/gv;
  *zc=(ax*x+ay*y+az*z)/ga;
  *nxc=(hx*nx+hy*ny+hz*nz)/gh;
  *nyc=(vx*nx+vy*ny+vz*nz)/gv;
  *nzc=(ax*nx+ay*ny+az*nz)/ga;
}

Surf1Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float r,R=30;
 r=R*sin(u*PI);
 *x=r*cos(v*PI*2); *y=r*sin(v*PI*2); *z=R*cos(u*PI); *nx=*x; *ny=*y; *nz=*z;
}

Surf2Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float r,R=15;
 r=R*sin(u*PI);
 *x=r*cos(v*PI*2)-70; *y=r*sin(v*PI*2)+70; *z=R*cos(u*PI)+40;
 *nx=*x+70; *ny=*y-70; *nz=*z-40;
}

Surf3Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float R=60;
 *x=R*cos(v*PI*2); *y=R*sin(v*PI*2)-50; *z=R*(u+0.25)/4;
 *nx=*x; *ny=*y+50; *nz=0;
}

Surf4Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{
  *x=100*u; *y=100*v; *z=0; *nx=0; *ny=0; *nz=1;
}

Surf5Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float alfa,a=300,b=50,l,k=8*PI,s,c;
  l=b*v; alfa=k*u; s=sin(alfa); c=cos(alfa);
  *x=l*c; *y=a*(u-0.5); *z=l*s;
  *nx=a*b*s; *ny=k*b*l; *nz=-a*b*c;
}
