#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include "graphics.c"
#define PI 3.14159
#define INF 32000
#define NP    100
#define NBx   150
#define NBy   100
#define NX    300
#define NY    200
#define nSurf   6

float EDist2();

float hx,hy,hz,vx,vy,vz,ax,ay,az,gh,gv,ga;
float p,u1[NP],u2[NP],v1[NP],v2[NP],
      x12[NP],y12[NP],z12[NP],
      x24[NP],y24[NP],z24[NP],
      x13[NP],y13[NP],z13[NP],
      x34[NP],y34[NP],z34[NP],
      xc[NP],yc[NP],zc[NP],nxc[NP],nyc[NP],nzc[NP];
short s[NP],cS,nColor;
short tp,sx,sy,sz,F, far **zbuff;
long pal[256];
main()
{ short k,n;
  if( (zbuff = (short far **)_fmalloc(NX*sizeof(short far *))) == NULL) exit(1);
  for( k = 0; k < NX; k++)
   if( (zbuff[k] = (short far *)_fmalloc(NY*sizeof(short))) == NULL) exit(2);
  OpenGraphics256(); _setwindow(1,0,0,319,199); _setvieworg(160,-100);
  nColor=6; SetPalette(); SetBackground();
  while( 1)
  { _settextposition(1,1); printf("\nsx sy sz F p nColor: ");
    scanf("%d %d %d %d %g %d",&sx,&sy,&sz,&F,&p,&nColor);
    if( nColor != 1 && (nColor < 4 || 6 < nColor)) nColor=6;
    SetPalette(); SetBackground();
    for( k = 0; k < NX; k++)
     for( n = 0; n < NY; n++) zbuff[k][n]=INF;
    TransfCoef();
    Draw(); printf("*"); getch();
/*
    Filter(); printf("\n*"); getch();
    Filter(); printf("\n*"); getch();
    Filter(); printf("\n*"); getch();
*/
  }
  CloseGraphics();
  exit(0);
}

SetPalette()
{ short k;
  switch (nColor)
  { case 1: cS=63;
	    for( k =   0; k <  64; k++)   pal[k] = RGB(k,k,k);
	    for( k =  64; k < 256; k++)   pal[k] = RGB(0,0,0);
	    break;
    case 4: cS=63;
	    for( k =   0; k <  64; k++)   pal[k] = RGB(k,k,k);
	    for( k =  64; k < 128; k++)   pal[k] = RGB(k-64,0,0);
	    for( k = 128; k < 192; k++)   pal[k] = RGB(0,k-128,0);
	    for( k = 192; k < 256; k++)   pal[k] = RGB(0,0,k-192);
	    break;
    case 5: cS=50;
	    for( k =   0; k <  51; k++)   pal[k] = RGB(k+13,k+13,k+13);
	    for( k =  51; k < 102; k++)   pal[k] = RGB(k-51+13,0,0);
	    for( k = 102; k < 153; k++)   pal[k] = RGB(0,k-102+13,0);
	    for( k = 153; k < 204; k++)   pal[k] = RGB(0,0,k-153+13);
	    for( k = 204; k < 255; k++)   pal[k] = RGB(k-204+13,k-204+13,0);
	    pal[255] = RGB(0,0,0);
	    break;
    case 6: cS=44;
	    for( k =   0; k <  45; k++)   pal[k] = RGB(k+19,k+19,k+19);
	    for( k =  45; k <  90; k++)   pal[k] = RGB(k-45+19,0,0);
	    for( k =  90; k < 135; k++)   pal[k] = RGB(0,k-90+19,0);
	    for( k = 135; k < 180; k++)   pal[k] = RGB(0,0,k-135+19);
	    for( k = 180; k < 225; k++)   pal[k] = RGB(k-180+19,k-180+19,0);
	    for( k = 225; k < 256; k++)   pal[k] = RGB(k-225,(k-225)/2,0);
	    break;
  }
  if( !_remapallpalette( pal ) )
   { _setvideomode( _DEFAULTMODE );
     _outtext( "Palettes not available with this adapter" );
     exit( 1 );
   }
}

SetBackground()
{ switch (nColor)
  { case 1: _setcolor(28); break;
    case 4: _setcolor(28); break;
    case 5: _setcolor(15); break;
    case 6: _setcolor( 9); break;
  }
  _rectangle_w(_GFILLINTERIOR,-160,-100,160,100);
}

TransfCoef()
{ vx=-sx; vy=-sy; vz=-sz;
  hx=vy; hy=-vx; hz=0; if( hx == 0 && hy == 0) { hx=0; hy=1; }
  ax=hy*vz-hz*vy;
  ay=hz*vx-hx*vz;
  az=hx*vy-hy*vx;
  gh=sqrt(hx*hx+hy*hy+hz*hz);
  gv=sqrt(vx*vx+vy*vy+vz*vz);
  ga=sqrt(ax*ax+ay*ay+az*az);
}

Draw()
{ short i; float du,dv;
  for(tp=0,i=1; i<=nSurf; i++)
  { u1[tp]  =0.0; u2[tp]  =0.5; v1[tp]  =0.0; v2[tp]  =0.5; s[tp]  =i;
    u1[tp+1]=0.5; u2[tp+1]=1.0; v1[tp+1]=0.0; v2[tp+1]=0.5; s[tp+1]=i;
    u1[tp+2]=0.0; u2[tp+2]=0.5; v1[tp+2]=0.5; v2[tp+2]=1.0; s[tp+2]=i;
    u1[tp+3]=0.5; u2[tp+3]=1.0; v1[tp+3]=0.5; v2[tp+3]=1.0; s[tp+3]=i;
    tp+=4;
  }
  for(i=0; i<tp; i++)
  { SurfPoint(s[i],(u1[i]+u2[i])/2,v1[i],i,12);
    SurfPoint(s[i],u2[i],(v1[i]+v2[i])/2,i,24);
    SurfPoint(s[i],u1[i],(v1[i]+v2[i])/2,i,13);
    SurfPoint(s[i],(u1[i]+u2[i])/2,v2[i],i,34);
    SurfPoint(s[i],(u1[i]+u2[i])/2,(v1[i]+v2[i])/2,i,0);
  }
  tp--;
  while( tp >= 0)
  { if( kbhit()) if(getch() == 27) return(0);
    PatchSize(&du,&dv);
    if( du <= p && dv <= p) { DrawPixel(); tp--; continue; }
    if( du > dv)  SplitU(); else SplitV();
    tp++;
  }
}

PatchSize(du,dv)
float *du,*dv;
{ float xp1u,yp1u,xp2u,yp2u,xp1v,yp1v,xp2v,yp2v,xpc,ypc;
  if( F <= 0)
  { *du=1.44*F*F*(EDist2(x13[tp],z13[tp],xc[tp],zc[tp])+
		  EDist2(x24[tp],z24[tp],xc[tp],zc[tp]));
    *dv=1.44*F*F*(EDist2(x12[tp],z12[tp],xc[tp],zc[tp])+
		  EDist2(x34[tp],z34[tp],xc[tp],zc[tp]));
  }
  else
  { xp1u=x13[tp]/y13[tp]; yp1u=z13[tp]/y13[tp];
    xp2u=x24[tp]/y24[tp]; yp2u=z24[tp]/y24[tp];
    xp1v=x12[tp]/y12[tp]; yp1v=z12[tp]/y12[tp];
    xp2v=x34[tp]/y34[tp]; yp2v=z34[tp]/y34[tp];
    xpc =xc[tp]/yc[tp];   ypc =zc[tp]/yc[tp];
    *du=1.44*F*F*NBx*NBx*(EDist2(xp1u,yp1u,xpc,ypc)+
			  EDist2(xp2u,yp2u,xpc,ypc));
    *dv=1.44*F*F*NBx*NBx*(EDist2(xp1v,yp1v,xpc,ypc)+
			  EDist2(xp2v,yp2v,xpc,ypc));
  }
}

float EDist2(x1,y1,x2,y2)
float x1,y1,x2,y2;
{ return((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));}

SplitU()
{ if(tp+1 > NP-1) exit(112);
  s[tp+1]=s[tp];
  u1[tp+1]=u1[tp]; u2[tp+1]=(u1[tp]+u2[tp])/2;
  v1[tp+1]=v1[tp]; v2[tp+1]=v2[tp];
  u1[tp]=u2[tp+1];
  x13[tp+1]=x13[tp]; y13[tp+1]=y13[tp]; z13[tp+1]=z13[tp];
  x24[tp+1]=xc[tp]; y24[tp+1]=yc[tp]; z24[tp+1]=zc[tp];
  SurfPoint(s[tp],(u1[tp+1]+u2[tp+1])/2,v1[tp+1],tp+1,12);
  SurfPoint(s[tp],(u1[tp+1]+u2[tp+1])/2,v2[tp+1],tp+1,34);
  SurfPoint(s[tp],(u1[tp+1]+u2[tp+1])/2,(v1[tp+1]+v2[tp+1])/2,tp+1,0);
  x13[tp]=xc[tp]; y13[tp]=yc[tp]; z13[tp]=zc[tp];
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,v1[tp],tp,12);
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,v2[tp],tp,34);
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,(v1[tp]+v2[tp])/2,tp,0);
}

SplitV()
{ if(tp+1 > NP-1) exit(112);
  s[tp+1]=s[tp];
  v1[tp+1]=v1[tp]; v2[tp+1]=(v1[tp]+v2[tp])/2;
  u1[tp+1]=u1[tp]; u2[tp+1]=u2[tp];
  v1[tp]=v2[tp+1];
  x12[tp+1]=x12[tp]; y12[tp+1]=y12[tp]; z12[tp+1]=z12[tp];
  x34[tp+1]=xc[tp]; y34[tp+1]=yc[tp]; z34[tp+1]=zc[tp];
  SurfPoint(s[tp],u1[tp+1],(v1[tp+1]+v2[tp+1])/2,tp+1,13);
  SurfPoint(s[tp],u2[tp+1],(v1[tp+1]+v2[tp+1])/2,tp+1,24);
  SurfPoint(s[tp],(u1[tp+1]+u2[tp+1])/2,(v1[tp+1]+v2[tp+1])/2,tp+1,0);
  x12[tp]=xc[tp]; y12[tp]=yc[tp]; z12[tp]=zc[tp];
  SurfPoint(s[tp],u1[tp],(v1[tp]+v2[tp])/2,tp,13);
  SurfPoint(s[tp],u2[tp],(v1[tp]+v2[tp])/2,tp,24);
  SurfPoint(s[tp],(u1[tp]+u2[tp])/2,(v1[tp]+v2[tp])/2,tp,0);
}

DrawPixel()
{ short x,y,k;
  if( F <= 0)
  { x=1.2*(-F)*xc[tp]; y=(-F)*zc[tp];
    if( x <= -NBx || y <= -NBy || x > NBx || y > NBy) return(0);
    if( zbuff[x+NBx][y+NBy] <= (short)(50*yc[tp])) return(0);
    zbuff[x+NBx][y+NBy]=50*yc[tp];
    k=cS*fabs(nyc[tp])/sqrt(nxc[tp]*nxc[tp]+nyc[tp]*nyc[tp]+nzc[tp]*nzc[tp]);
  }
  else
  { if( yc[tp] < F) return(0);
    x=1.2*F*NBx*xc[tp]/yc[tp]; y=F*NBx*zc[tp]/yc[tp];
    if( x <= -NBx || y <= -NBy || x > NBx || y > NBy) return(0);
    if( zbuff[x+NBx][y+NBy] <= (short)(50*yc[tp])) return(0);
    zbuff[x+NBx][y+NBy]=50*yc[tp];
    k=cS*fabs(xc[tp]*nxc[tp]+yc[tp]*nyc[tp]+zc[tp]*nzc[tp])/
	 sqrt((xc[tp]*xc[tp]+yc[tp]*yc[tp]+zc[tp]*zc[tp])*
	      (nxc[tp]*nxc[tp]+nyc[tp]*nyc[tp]+nzc[tp]*nzc[tp]));
  }
  switch (nColor)
  { case 1: break;
    case 4: if(s[tp]==1) k+=192;
	    if(s[tp]==2) k+=128;
	    if(s[tp]==3) k+=0;
	    if(s[tp]==4) k+=128;
	    if(s[tp]==5) k+=64;
	    if(s[tp]==6) k+=0;     break;
    case 5: if(s[tp]==1) k+=204;
	    if(s[tp]==2) k+=102;
	    if(s[tp]==3) k+=51;
	    if(s[tp]==4) k+=153;
	    if(s[tp]==5) k+=0;
	    if(s[tp]==6) k+=51;     break;
    case 6: if(s[tp]==1) k+=180;
	    if(s[tp]==2) k+=90;
	    if(s[tp]==3) k+=45;
	    if(s[tp]==4) k+=135;
	    if(s[tp]==5) k+=0;
	    if(s[tp]==6) k=k*30/44+225;     break;
  }
  _setcolor(k); _setpixel_w(x,y);
}

SurfPoint(s,u,v,t,k)
short s,t,k; float u,v;
{ float x,y,z,nnx,nny,nnz,xk,yk,zk,nx,ny,nz;
  switch (s)
  { case 1: Surf1Point(u,v,&x,&y,&z,&nnx,&nny,&nnz); break;
    case 2: Surf2Point(u,v,&x,&y,&z,&nnx,&nny,&nnz); break;
    case 3: Surf3Point(u,v,&x,&y,&z,&nnx,&nny,&nnz); break;
    case 4: Surf4Point(u,v,&x,&y,&z,&nnx,&nny,&nnz); break;
    case 5: Surf5Point(u,v,&x,&y,&z,&nnx,&nny,&nnz); break;
    case 6: Surf6Point(u,v,&x,&y,&z,&nnx,&nny,&nnz); break;
  }
  xk=(hx*x+hy*y+hz*z)/gh;
  yk=(vx*x+vy*y+vz*z)/gv+gv;
  zk=(ax*x+ay*y+az*z)/ga;
  nx=(hx*nnx+hy*nny+hz*nnz)/gh;
  ny=(vx*nnx+vy*nny+vz*nnz)/gv;
  nz=(ax*nnx+ay*nny+az*nnz)/ga;
  switch (k)
  { case 12: x12[t]=xk; y12[t]=yk; z12[t]=zk; break;
    case 24: x24[t]=xk; y24[t]=yk; z24[t]=zk; break;
    case 13: x13[t]=xk; y13[t]=yk; z13[t]=zk; break;
    case 34: x34[t]=xk; y34[t]=yk; z34[t]=zk; break;
    case  0: xc[t]=xk;  yc[t]=yk;  zc[t]=zk;
	     nxc[t]=nx; nyc[t]=ny; nzc[t]=nz; break;
  }
}

Surf1Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float r,R=3;
 r=R*sin(u*PI);
 *x=r*cos(v*PI*2); *y=r*sin(v*PI*2); *z=R*cos(u*PI); *nx=*x; *ny=*y; *nz=*z;
}

Surf2Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float r,R=1.5;
 r=R*sin(u*PI);
 *x=r*cos(v*PI*2)-7; *y=r*sin(v*PI*2)+7; *z=R*cos(u*PI)+4;
 *nx=*x+7; *ny=*y-7; *nz=*z-4;
}

Surf3Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float R=6;
 *x=R*cos(v*PI*2); *y=R*sin(v*PI*2)-5; *z=R*(u+0.025)/4;
 *nx=*x; *ny=*y+5; *nz=0;
}

Surf4Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{
  *x=10*u; *y=10*v; *z=0; *nx=0; *ny=0; *nz=1;
}

Surf5Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float alfa,a=30,b=5,l,k=8*PI,s,c;
  l=b*v; alfa=k*u; s=sin(alfa); c=cos(alfa);
  *x=l*c; *y=a*(u-0.5); *z=l*s;
  *nx=a*b*s; *ny=k*b*l; *nz=-a*b*c;
}

Surf6Point(u,v,x,y,z,nx,ny,nz)
float u,v,*x,*y,*z,*nx,*ny,*nz;
{ float r=1,R=3,su,cu,sv,cv;
  su=sin(2*PI*u); cu=cos(2*PI*u);
  sv=sin(2*PI*v); cv=cos(2*PI*v);
  *nx=r*cv*cu; *ny=r*cv*su; *nz=r*sv;
  *x=R*cu+*nx+10; *y=R*su+*ny; *z=*nz;
}

Filter()
{ short r[NX][3],i,j,k,l,s,a,b;
  for(k=0; k<3; k++) for(i=-NBx; i<NBx; i++) r[i+NBx][k]=_getpixel_w(i,k-NBy);
  k=0;
  for(j=-NBy+1; j<NBy-2; j++)
  { _setcolor(63); _setpixel_w(159,j);
    for(i=1; i<NX-1; i++)
    { l=(k < 2)? k+1: 0;
      s=r[i-1][l]+r[i][0]+r[i][1]+r[i][2]+r[i+1][l];
      a=min(min(min(r[i-1][l],r[i][0]),min(r[i][1],r[i][2])),r[i+1][l]);
      b=max(max(max(r[i-1][l],r[i][0]),max(r[i][1],r[i][2])),r[i+1][l]);
      if( (7*a+3*b <= 2*s && 2*s <= 3*a+7*b) || a < 10)
      { _setcolor(s/5); _setpixel_w(i-NBx,j); }
    }
    for(i=-NBx; i<NBx; i++) r[i+NBx][k]=_getpixel_w(i,j+2);
    k=l;
    _setcolor(20); _setpixel_w(159,j);
  }
}
