#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "graphics.c"
#define PI 3.14159
#define INF 32767
float sinc(float);

short nf,xs,ys,si,sj,minrow[800],maxrow[800];
float xc,yc,zc,a;
main()
{ short i,j,valrow[800];
  OpenGraphics(); _setwindow(1,0,0,639,479);
  _remappalette( 0,RGB(40,40,40));
  _remappalette(7,RGB(20,5,0));
  _setcolor(6);
  while(1)
  { PrintFunclist();
    _settextposition(1,1);
    printf("nf:  "); scanf("%d",&nf); if (nf==0) return(0);
    printf("si sj:  "); scanf("%d %d",&si,&sj);
    printf("xc yc zc a:  "); scanf("%g %g %g %g",&xc,&yc,&zc,&a);
    if( fabs(a) < 10e-10) continue;
    _setviewport(0,70,639,479); _clearscreen(_GVIEWPORT);
    _setviewport(0,0,639,479);
    for(i=0; i<800; i++) { minrow[i]=INF; maxrow[i]=-INF; }
    for(j=-150/sj; j<=150/sj; j++)
    { for(i=0; i<=600/si; i++) valrow[i]=funval(i,j);
      xs=20+sj*j; ys=valrow[0]+240+sj*j;
      for(i=1; i<=600/si; i++)
       Lineto(xs+si,valrow[i]+240+sj*j);
    }
    getch();
    _clearscreen(_GCLEARSCREEN);
  }
  CloseGraphics();
}

funval(short i, short j)
{ float x,y,fun(float,float);
  y=yc+i*si*a/300-a; x=xc-j*sj*a/150;
  return((short)((fun(x,y)-zc)*300/a));
}

Lineto(short xf, short yf)
{long x,y,xx,yp,yt,z;
 xx=xf;
 if(xf > 0 && xs < 640 && xs < xf)
 { if( xs < 0) xs=0;
   if( xf > 639) xf=640;
   if(xf-xs >= abs(yf-ys))
   for(x=xs; x<=xf; x++)
    { y=ys+(yf-ys)*(x-xs)/(xf-xs);
      if( y < minrow[x] || maxrow[x] < y)
      { _setpixel_w((short)x,(short)y);
	if( minrow[x] > y) minrow[x]=y;
	if( maxrow[x] < y) maxrow[x]=y;
      }
    }
   else
    { z=(ys < yf) ? 1: -1;
      yp=ys;
      for(x=xs; x<=xf; x++)
      { yt=ys+(yf-ys)*(x-xs)/(xf-xs);
	for(y=yp+z; y*z<=yt*z; y+=z)
	if( y < minrow[x] || maxrow[x] < y) _setpixel_w((short)x,(short)y);
	if( yp < yt)
	{ if( minrow[x] > yp+1) minrow[x]=yp+1;
	  if( maxrow[x] < yt) maxrow[x]=yt;
	}
	else
	{ if( minrow[x] > yt) minrow[x]=yt;
	  if( maxrow[x] < yp-1) maxrow[x]=yp-1;
	}
	yp=yt;
      }
    }
   }
 xs=xx; ys=yf;
}

float fun(float x, float y)
{ switch (nf)
{ case 1: return(sin(y));
  case 2: return(sin(x)*sin(y));
  case 3: return(cos(sqrt(x*x+y*y)));
  case 4: return(-cos(x*x+y*y)*exp(-(x*x+y*y)/10)*4.5);
  case 5: return(x*y);
  case 6: return(x*x-y*y);
  case 7: return(y*y);
  case 8: return(max(-4,max(5-sqrt((x-2)*(x-2)+(y+2)*(y+2))*2,
			    5-sqrt((x+2)*(x+2)+(y-2)*(y-2))*2)));
  case 9: return(max(-2,4-(short)((x*x+y*y)/3)));
  case 10: return( (y<-4 || y>4)? 0: -(short)x);
  case 11: return(max(-4,max(5-sqrt((x-2)*(x-2)+(y+2)*(y+2))*2,
				 (y<-4 || y>4)? 0: -(short)x)));
  case 12: return(sinc(x)*sinc(y));
  default: return(0);
}
}

PrintFunclist()
{ _settextposition(5,1);
  printf("\n  1: sin(y)");
  printf("\n  2: sin(x)*sin(y)");
  printf("\n  3: cos(sqrt(x*x+y*y))");
  printf("\n  4: -cos(x*x+y*y)*exp(-(x*x+y*y)/10)*4.5");
  printf("\n  5: x*y");
  printf("\n  6: x*x-y*y");
  printf("\n  7: y*y");
  printf("\n  8: max(-4,max(5-sqrt((x-2)*(x-2)+(y+2)*(y+2))*2,");
  printf("\n                5-sqrt((x+2)*(x+2)+(y-2)*(y-2))*2))");
  printf("\n  9: max(-2,4-(short)((x*x+y*y)/3))");
  printf("\n 10: (y<-4 || y>4)? 0: -(short)x");
  printf("\n 11: max(-4,max(5-sqrt((x-2)*(x-2)+(y+2)*(y+2))*2,");
  printf("\n                (y<-4 || y>4)? 0: -(short)x))");
  printf("\n 12: sinc(x)*sinc(y)");

}

float sinc(float x)
{ return( fabs(x) < .001 ? 1. : sin(PI*x)/PI/x);}
