/* ANIMATE.C illustrates animation functions including:
 *      _imagesize     _getimage     _putimage
 */

#include <conio.h>
#include <stddef.h>
#include <stdlib.h>
#include <malloc.h>
#include <graph.h>
#include <math.h>
#include "timesys.c"

#define PI 3.14159

short action[5]  = { _GPSET,   _GPRESET, _GXOR,    _GOR,     _GAND    };
char *descrip[5] = { "PSET  ", "PRESET", "XOR   ", "OR    ", "AND   " };

main()
{   short fr=80;
    char far *buffer;
    size_t imsize;
    short i, j, xr, yr, sx, x, y, mode = _VRES16COLOR;

    while( !_setvideomode( mode ) )         /* Find a valid graphics mode */
	mode--;
    if (mode == _TEXTMONO )
	exit( 1 );                          /* No graphics available      */
    _setcolor( 3 );
    for ( i = 0; i < 1/*5*/; i++ )
    {
	x = 150; y = 150;
	_settextposition( 1, 1 );           /* Display action type        */
	_outtext( descrip[i] );
					    /* Draw and measure ellipse   */
	_ellipse( _GBORDER, x - 70, y - 70, x + 70, y + 70 );
	_ellipse( _GBORDER, x - 60, y - 60, x + 60, y + 60 );
	_ellipse( _GBORDER, x - 10, y - 10, x + 10, y + 10 );
	_ellipse( _GFILLINTERIOR, x - 6, y - 6, x + 6, y + 6 );
	imsize = (size_t)_imagesize( x - fr, y - fr, x + fr, y + fr );
	buffer = (char far *)_fmalloc( imsize );
	if ( buffer == (char far *)NULL )
	    exit( !_setvideomode( _DEFAULTMODE ) );
					    /* Get master copy of ellipse */
	_getimage( x - fr, y - fr, x + fr, y + fr, buffer );
	j=0;
	while( !kbhit())                    /* Copy row of ellipses       */
	{                                   /*   with specified action    */
	    x += 3-rand()%5; y += 2-rand()%4;
	    _putimage( x - fr, y - fr, buffer, action[i] );
	    _moveto(x,y);
	    xr=x+70*cos(PI/60*j);
	    yr=y+70*sin(PI/60*j++);
	    _lineto(xr,yr);
	    pause(.00013);
	}
	_ffree( buffer );                   /* Free memory                */
	getch();
    }
    exit( !_setvideomode( _DEFAULTMODE ) );
}
